﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Public fchoose As FileChooser
	Public converter As BalConverter
	Public filepath As String
	Public jsonfilename As String
	Public bjlfilename As String
	Public sourcestring As String
	Public sourcemap As Map
	Private btnsource As Button
	Private btnstart As Button
	Private lblresult As Label
	Private lblsource As Label
	Private taresult As TextArea
	Private tasource As TextArea
	Private typepropertiesmap As Map
	Private typepropertiesstring As String
	Private lblbjlfile As Label
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Layoutconverter")
	fchoose.Initialize
	xui.SetDataFolder("Layoutconverter")
	typepropertiesmap.Initialize
	typepropertiesstring = File.ReadString(File.DirAssets,"typeproperties.json")
	typepropertiesmap = typepropertiesstring.As(JSON).ToMap
End Sub
Private Sub reset_interface
	lblsource.Text = ""
	tasource.Text = ""
	lblresult.Text = ""
	taresult.Text = ""
	lblbjlfile.Text = ""
End Sub
Private Sub btnsource_Click
	reset_interface
	fchoose.setExtensionFilter("JSON", Array As String("*.json"))
	fchoose.InitialDirectory = xui.DefaultFolder
	fchoose.InitialFileName = ""
	Dim filename As String = fchoose.ShowOpen(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename = "" Then Return
	Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
	Dim jsonfilename As String = filename.SubString(filename.LastIndexOf("\")+1)
	Log(filepath)
	Log(jsonfilename)
	If filename <> "" Then
		If filename.EndsWith(".json") Then
			lblsource.Text = " " & filename
			sourcestring = File.ReadString(filepath, jsonfilename)
			If check_valid_json("string") = False Then Return
			sourcemap = sourcestring.As(JSON).ToMap
			If check_valid_json("map") = False Then Return
			sourcemap.Remove("Storyboard")
			tasource.Text = sourcemap.As(JSON).ToString
		End If
	End If
End Sub
Private Sub check_valid_json(test As String) As Boolean
	If test = "map" Then
		If sourcemap.ContainsKey("Storyboard") = False Then
			xui.MsgboxAsync("This source file is not a valid Storyboard JSON file." & CRLF & _
							"Save the card with the Storyboard card application using the latest update." & CRLF & _
							"Click on the Source button to select the correct file.","Source file")
			sourcemap.Clear
			Return False
		Else
			Return True
		End If
	End If
	If test = "string" Then
		If sourcestring.StartsWith("{") = False Then
			xui.MsgboxAsync("This source file is not a valid Storyboard JSON file." & CRLF & _
							"Save the card with the Storyboard card application using the latest update." & CRLF & _
							"Click on the Source button to select the correct file.","Source file")
			Return False
		Else
			Return True
		End If
	End If
	Return False
End Sub
Private Sub btnstart_Click
	If sourcemap.IsInitialized = False Then Return
	If sourcemap.Size = 0 Then Return
	For Each name As String In sourcemap.Keys
		If name.Contains("card") = False Then
			Dim shapemap As Map = sourcemap.Get(name)
			Dim chtype As String = shapemap.Get("type")
			If typepropertiesmap.ContainsKey(chtype) = False Then
				xui.MsgboxAsync("The JSON source contains an invalid view type." & _
								CRLF & "Use the Storyboard application latest version to adjust.","JSON Source")
				Return
			End If
		End If
	Next
	create_json_layout_file	
End Sub
Private Sub create_json_layout_file
	Dim materialicons As Boolean = False
	Dim fontawesome As Boolean = False
	Dim variants As List = convertfunctions.set_variants_list
	Dim layoutheader As Map = convertfunctions.set_layoutheader_map(sourcemap,typepropertiesmap)
	Dim data As Map = convertfunctions.set_data_map(sourcemap,typepropertiesmap)
	Dim mainmap As Map = convertfunctions.set_main_map(materialicons,fontawesome,variants,layoutheader,data)
	Log(mainmap.As(JSON).ToString)
	save_json_to_file(mainmap.As(JSON).ToString)
End Sub
Private Sub save_json_to_file(jsonstring As String)
	If jsonstring.Contains("null") Then
		xui.MsgboxAsync("The JSON string contains invalid values!" & CRLF & _
						"Save the card with the Storyboard card application using the latest update." & CRLF & _	
						"Click on the Source button to select the correct file.", _
						"JSON string")
		Return
	End If
	fchoose.setExtensionFilter("JSON", Array As String("*.json"))
	fchoose.InitialDirectory = xui.DefaultFolder
	fchoose.InitialFileName = ""
	Dim filename As String = fchoose.ShowSave(B4XPages.GetNativeParent(B4XPages.MainPage))
	If filename = "" Then Return
	Dim filepath As String = filename.SubString2(0,filename.LastIndexOf("\"))
	Dim jsonfilename As String = filename.SubString(filename.LastIndexOf("\")+1)
	Log(filepath)
	Log(jsonfilename)
	If filename <> "" Then
		If filename.EndsWith(".json") Then
			lblresult.Text = " " & filename
			taresult.Text = jsonstring
			File.WriteString(filepath, jsonfilename,jsonstring)
			bjlfilename = jsonfilename.SubString2(0,jsonfilename.LastIndexOf("."))
			convert_json_to_bjl
			lblbjlfile.Text = filepath & "\" & bjlfilename & ".bjl"
		End If
	End If
End Sub
Private Sub convert_json_to_bjl
	converter.Initialize(False)
	converter.ConvertJsonToBal(filepath, jsonfilename)
	xui.MsgboxAsync("The conversion was succesfull.","Convert")
	Sleep(2000)
End Sub
