﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.95
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private xui As XUI
End Sub

#Region listfunctions
Public Sub set_variants_list As List
	Dim lst As List
	lst.Initialize
	Dim vmap As Map = CreateMap("Scale":1,"Height":600,"Width":600)
	lst.Add(vmap)		
	Return lst
End Sub
Public Sub set_designerscript As List
	Dim lst As List
	lst.Initialize
	lst.Add("'All variants script\n")
	lst.Add("'Variant specific script: 600x600,scale=1\n")
	Return lst
End Sub
Public Sub set_controlsheaders(collectionmap As Map,typepropertiesmap As Map) As List
	Dim lst As List
	lst.Initialize
	For Each name As String In collectionmap.Keys
		Dim shapemap As Map = collectionmap.Get(name)
		If name.Contains("card") = True Then			' main
			lst.Add(set_header_map(".PaneWrapper$ConcretePaneWrapper","Pane","Main"))
		Else	' shapes
			Dim chtype As String = shapemap.Get("type")
			Dim typesmap As Map = typepropertiesmap.Get(chtype)
			Dim javatype As String = typesmap.Get("JavaType")
			Dim designertype As String = typesmap.Get("DesignerType")
			Dim cname As String = typesmap.Get("Name")
			lst.Add(set_header_map(javatype,designertype,cname))
		End If
	Next
	Return lst
End Sub
Public Sub set_fileslist As List
	Dim lst As List
	lst.Initialize
	Return lst
End Sub
#End Region

#Region mapfunctions
Public Sub set_main_map(materialicons As Boolean,fontawesome As Boolean,variants As List,layoutheader As Map,data As Map) As Map
	Dim mmap As Map = CreateMap("MaterialIcons":materialicons,"FontAwesome":fontawesome, _
								"Variants":variants,"LayoutHeader":layoutheader,"Data":data)
	Return mmap
End Sub

Public Sub set_layoutheader_map(collectionmap As Map,typepropertiesmap As Map) As Map
	Dim lhmap As Map = CreateMap("Version":5,"GridSize":10,"DesignerScript":set_designerscript, _
								 "ControlsHeaders":set_controlsheaders(collectionmap,typepropertiesmap), _
								 "Files":set_fileslist)
	Return lhmap
End Sub

Public Sub set_header_map(javatype As String, designertype As String, name As String) As Map
	Dim chmap As Map = CreateMap("JavaType":javatype,"DesignerType":designertype,"Name":name)
	Return chmap
End Sub

Public Sub set_data_map(collectionmap As Map,typepropertiesmap As Map) As Map
	Dim datamap As Map
	datamap.Initialize
	For Each name As String In collectionmap.Keys
		Dim shapemap As Map = collectionmap.Get(name)
		If name.Contains("card") = True Then
			' Main data
			datamap.Put("parent","")
			datamap.Put("borderColor",set_color_map(6,"0xFF000000"))	' not set in Storyboard app
			' todo set background color if exists in shapemap
			datamap.Put("drawable",set_drawable_map("0xFFF0F8FF"))
			datamap.Put("orientation","INHERIT")
			datamap.Put("visible",True)
			datamap.Put("csType","Dbasic.Designer.MetaMain")
			datamap.Put("handleResizeEvent",True)
			datamap.Put("type",".PaneWrapper$ConcretePaneWrapper")
			datamap.Put("title","Form")
			datamap.Put("enabled",True)
			datamap.Put("variant0",set_varinfo_map(shapemap))
			datamap.Put("cornerRadius",set_type_value_map(7,0))
			datamap.Put("javaType",".PaneWrapper$ConcretePaneWrapper")
			datamap.Put("duration",0)
			datamap.Put("file","")
			datamap.Put("borderWidth",set_type_value_map(7,0))
			datamap.Put("alpha",set_type_value_map(7,1))
			datamap.Put("name","Main")
			datamap.Put("eventName","MainForm")
			datamap.Put("extraCss","")
			datamap.Put("tag","")
		End If
	Next
	' kids data
	Dim kidsmap As Map
	kidsmap.Initialize
	Dim kidcnt As Int = 0
	For Each name As String In collectionmap.Keys
		Dim shapemap As Map = collectionmap.Get(name)
		If name.Contains("card") = False Then
			kidsmap.Put(kidcnt,set_kid_map(shapemap,typepropertiesmap))
			kidcnt = kidcnt + 1
		End If
	Next
	datamap.Put(":kids",kidsmap)
	Return datamap
End Sub

Public Sub set_kid_map(shapemap As Map,typepropertiesmap As Map) As Map
	Dim chtype As String = shapemap.Get("type")
	Dim textcolor As String = shapemap.Get("textcolor")
	Dim backgroundcolor As String = shapemap.Get("backgroundcolor")
	Dim typesmap As Map = typepropertiesmap.Get(chtype)
	Dim javatype As String = typesmap.Get("JavaType")
	Dim cstype As String = typesmap.Get("csType")
	Dim shorttype As String = typesmap.Get("shortType")
	Dim kmap As Map
	kmap.Initialize
	kmap.Put("parent","Main")
	kmap.Put("borderColor",set_color_map(6,"0xFF000000"))	' not set in storyboard app - default black
	kmap.Put("shadow",set_shadow_map)
	kmap.Put("vanchor",0)
	kmap.Put("type",javatype)
	kmap.Put("enabled",True)
	kmap.Put("variant0",set_varinfo_map(shapemap))
	kmap.Put("cornerRadius",set_type_value_map(7,shapemap.Get("cornerradius")))
	kmap.Put("top",100)
	kmap.Put("borderWidth",set_type_value_map(7,shapemap.Get("strokewidth")))
	kmap.Put("alpha",set_type_value_map(7,1))
	kmap.Put("hanchor",0)
	kmap.Put("eventName",shapemap.Get("eventname"))
	kmap.Put("tag","")
	kmap.Put("text",shapemap.Get("text"))
	kmap.Put("wrapText",shapemap.Get("wraptext"))
	kmap.Put("height",100)
	If backgroundcolor.Contains(",") = True Then
		Dim RGB As List = set_RGB_values(shapemap.Get("backgroundcolor"))
		Dim hexcolor As String = "0x" & ColorToHex(xui.Color_ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2)))
		kmap.Put("drawable",set_drawable_map(hexcolor))
	Else
		kmap.Put("drawable",set_drawable_map("0x00FFFFFF"))		' default transparent
	End If
	kmap.Put("visible",True)
	kmap.Put("csType",cstype)
	kmap.Put("fontAwesome","")
	kmap.Put("toolTip","")
	If textcolor.Contains(",") = True Then
		Dim RGB As List = set_RGB_values(shapemap.Get("textcolor"))
		Dim hexcolor As String = "0x" & ColorToHex(xui.Color_ARGB(255,RGB.Get(0),RGB.Get(1),RGB.Get(2)))
		kmap.Put("textColor",set_color_map(6,hexcolor))
	Else
		kmap.Put("textColor",set_color_map(6,"0xFF000000"))		' black
	End If
	kmap.Put("javaType",javatype)
	kmap.Put("contextMenu","")
	kmap.Put("left",100)
	kmap.Put("materialIcons","")
	kmap.Put("name",shapemap.Get("name"))
	kmap.Put("width",100)
	kmap.Put("extraCss","")
	kmap.Put("alignment",shapemap.Get("alignment"))
	kmap.Put("font",set_font_map(shapemap.Get("fontfamily"),shapemap.Get("fontsize"),shapemap.Get("textbold"),shapemap.Get("textitalic")))
	If typepropertiesmap.ContainsKey(chtype) Then
		If typesmap.Get("DesignerType") = "CustomView" Then
			kmap.Put("shortType",shorttype)
			kmap.Put("customType",typesmap.Get("customType"))
			kmap.Put("customProperties",typesmap.Get("customProperties"))
		End If
		Dim skiplst As List = Array As String("shortType","javaType","DesignerType","csType","customType","customProperties","Name")
		For Each key As String In typesmap.Keys
			If skiplst.IndexOf(key) = -1 Then
				kmap.Put(key,typesmap.Get(key))
			End If
		Next
	End If
	Return kmap
End Sub

Public Sub set_font_map(name As String, size As Int, bold As Boolean, italic As Boolean) As Map
	Dim fmap As Map = CreateMap("fontName":name,"csType":"Dbasic.Designer.FontGrid", _
								"fontSize":set_type_value_map(7,size),"bold":bold,"type":"B4IFontWrapper", _
								"italic":italic)
	Return fmap
End Sub

Public Sub set_color_map(valuetype As Int, hexvalue As String) As Map
	Dim cmap As Map = CreateMap("ValueType":valuetype,"Value":hexvalue)
	Return cmap
End Sub


Public Sub set_type_value_map(valuetype As Int, value As Int) As Map
	Dim cmap As Map = CreateMap("ValueType":valuetype,"Value":value)
	Return cmap
End Sub

Public Sub set_drawable_map(color As String) As Map
	Dim drmap As Map = CreateMap("csType":"Dbasic.Designer.Drawable.ColorDrawable", _
								 "colorKey":"-fx-background-color","type":"ColorDrawable", _
								 "color":set_color_map(6,color))
	Return drmap
End Sub

Public Sub set_varinfo_map(shapemap As Map) As Map
	Dim vmap As Map = CreateMap("top":shapemap.Get("top"), _
								"left":shapemap.Get("left"),"width":shapemap.Get("width"), _
								"height":shapemap.Get("height"),"hanchor":0,"vanchor":0)
	Return vmap
End Sub

Public Sub set_shadow_map As Map
	Dim shmap As Map = CreateMap("offsetX":set_type_value_map(7,0),"offsetY":set_type_value_map(7,0), _
								 "csType":"Dbasic.Designer.ShadowGrid","stype":0,"type":"", _
								 "radius":set_type_value_map(7,10),"shadowColor":set_color_map(6,"0xFF000000"))
	Return shmap
End Sub
#End Region

#Region color functions
Public Sub ColorToHex(clr As Int) As String
	Dim bc As ByteConverter
	Return bc.HexFromBytes(bc.IntsToBytes(Array As Int(clr)))
End Sub
Public Sub set_RGB_values(clrstr As String) As List
	' clrstr = red,green,blue
	Dim lst As List
	lst.Initialize
	lst.Add(clrstr.SubString2(0,clrstr.IndexOf(",")))
	lst.Add(clrstr.SubString2(clrstr.IndexOf(",")+1,clrstr.LastIndexOf(",")))
	lst.Add(clrstr.SubString(clrstr.LastIndexOf(",")+1))
	Return lst
End Sub
#End Region
